<?php
/*
Plugin Name: Risal Download
Plugin URI: http://linuxuserjp.wordpress.com/
Description: Filter direct download of files. Manage how your files from outside ROOT_DIRECTORY will be downloaded. Monitor who download your files.
Version: 1.4
Author: Risal Affendie
Author URI: http://linuxuserjp.wordpress.com
Tags: abuse, download, session, browser, encrypt, security, secure, apache, token, linuxuserjp, risal
*/

global $table_prefix, $wpdb, $querySettings, $myrow;
$wpdb->hide_errors();
$wpdb->risfiles = $table_prefix . 'risfiles';
$wpdb->rissettings = $table_prefix . 'rissettings';
$wpdb->ristokens = $table_prefix . 'ristokens';
$installed = $wpdb->get_results("SELECT id FROM $wpdb->ristokens");

if (mysql_errno() == 1146) 
{
	$wpdb->query("DROP TABLE ".$wpdb->risfiles);
	$wpdb->query("DROP TABLE ".$wpdb->rissettings);
	
	$sql = "CREATE TABLE " . $wpdb->risfiles . " (
			  `id` int(11) NOT NULL auto_increment,
			  `file` varchar(128) NOT NULL,
			  `ip` varchar(16) NOT NULL,
			  `path` varchar(255) NOT NULL,
			  `valid` varchar(1) NOT NULL,
			  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
			  PRIMARY KEY  (`id`)
			)";
	$wpdb->query($sql);

	$sql = "CREATE TABLE " . $wpdb->rissettings . " (
			id mediumint(9) NOT NULL AUTO_INCREMENT,
			file varchar(128) NOT NULL,
			method VARCHAR(128) NOT NULL,
			outsidepath VARCHAR(255) NOT NULL,
			timing int(255) NOT NULL,
			UNIQUE KEY id (id)
			);";	
	$wpdb->query($sql);
	//Additional table for v1.4
	$sql = "CREATE TABLE " . $wpdb->ristokens . " (
			id mediumint(9) NOT NULL,
			token VARCHAR(255) NOT NULL,
			point timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
			PRIMARY KEY  (`token`)
			);";	
	$wpdb->query($sql);
}

///Put setting link into admin page (plugins.php).

add_action( 'admin_menu', 'risal_config_page' );

function risal_plugin_action_links( $links, $file ) {
	if ( $file == plugin_basename( dirname(__FILE__).'/risal-download.php' ) ) {
	$links[] = '<a href="plugins.php?page=risal">'.__('Settings').'</a>';
	}
	return $links;
}


add_filter( 'plugin_action_links', 'risal_plugin_action_links', 10, 2 );


function risal_config_page() {
	if ( function_exists('add_submenu_page') )
	add_submenu_page('plugins.php', __('Risal Configuration'), __('Risal Configuration'), 'manage_options', 'risal', 'risal_confx');
}

function browsefs() {
 // Explore the files via a web interface.   
  $xcript = basename(__FILE__); // the name of this script
	if ( $_GET['path'] == "" || !isset($_GET['path']) )
	{
	$xath = $_SERVER['DOCUMENT_ROOT'].dirname($_SERVER['PHP_SELF']);
	} else {
	$xath = $_GET['path'];
	}
  //$xath = !empty($_REQUEST['path']) ? $_REQUEST['path'] : $_SERVER['DOCUMENT_ROOT'].'/'.dirname($_SERVER['PHP_SELF'])/*dirname(__FILE__)*/; // the path the script should access
  
  echo "<p>Browsing Location: <input type=text size=70 readonly=readonly value=\"{$xath}\"></p>";

  $drtries = array();
  $tiles = array();
  
  // Check we are focused on a dir
  if (is_dir($xath)) {
    chdir($xath); // Focus on the dir
   if ($handle = opendir('.')) {
      while (($item = readdir($handle)) !== false) {
        // Loop through current directory and divide files and directorys
        if(is_dir($item)){
          array_push($drtries, realpath($item)); 
        }
        else
        {
          array_push($tiles, ($item));
        }
   }
   closedir($handle); // Close the directory handle
   }
    else {
      echo "<p class=\"error\">Directory handle could not be obtained.</p>";
    }
  }
  else
  {
    echo "<p class=\"error\">Path is not a directory</p>";
  }
  
  // There are now two arrays that contains the contents of the path. 
  
  // List the directories as browsable navigation
	
  echo '<table style="padding: 0; margin: 0;"><tr class=d0><td>Name</td><td>Size</td><td>Type</td></tr>';
  sort($drtries);
  $kira = 0;
  foreach( $drtries as $drtry ){
	if ( $xath !== $drtry ) {
	echo "<tr class=d1>";
	if ( dirname($xath) == $drtry ) {
	echo "<td><a href=\"plugins.php?page=risal&browse=true&path={$drtry}\" icon='sf'> .. </a></td>";
	} else {
	echo "<td><a href=\"plugins.php?page=risal&browse=true&path={$drtry}\" icon='sf'>".basename($drtry)."</a></td>";
	}
	echo "<td>".filesize($drtry)."</td><td>".mime_content_type($drtry)."</td></tr>";
	}
  }
  sort($tiles);
  foreach( $tiles as $tile ){
    // Comment the next line out if you wish see hidden files while browsing

    if(preg_match("/^\./", $tile) || $tile == $xcript): continue; endif; // This line will hide all invisible files.
	echo "<tr class=d1>";
    	echo '<td><a href="javascript:void(0)" onClick="refreshParent(\''.$tile.'\',\''.$xath.'\');" icon="f">' . $tile . '</a></td>';
	echo "<td>".filesize($xath.'/'.$tile)."</td><td>".mime_content_type($xath.'/'.$tile)."</td></tr>"; 
  }

  echo "</table>";

}


function risal_confx() {
echo '<div class="wrap"><div id="icon-plugins" class="icon32"><br /></div>';
if ( $_GET['browse'] !== "true" )
{
echo '<h2>Risal Download Configuration</h2>';
risal_conf();
} else {
echo '<h2>Risal Download Configuration: Browse File</h2>';
browsefs();
}
echo '<p> - Created by <a href="http://linuxuserjp.wordpress.com" target=_blank>Risal Affendie</a> - </p>';
}

function risal_conf() {
global $wpdb, $queryRisal, $myrow, $rissettings, $risfiles, $table_prefix, $tris, $vris, $myid;
$rissettings = $table_prefix . 'rissettings';
$risfiles = $table_prefix . 'risfiles';
echo '</div>
	<div class="rissdiv">';
///step 1: Create alert
	if ( $_POST['submit'] == "Insert" ) {
	$dename = $_POST['myfile'];
	$mycount = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(*) FROM $rissettings WHERE file = '$dename';" ) );
	if ( $mycount == 0 ) {
	$wpdb->insert( 
	$rissettings, 
	array( 
		'id' => basename($_POST['myid']), 
		'file' => $dename,
		'method' => $_POST['mymeth'], 
		'outsidepath' => $_POST['mypath'],
		'timing' => $_POST['mytime']
	));
	echo risal_displayonly('Inserted new record.');
	} else {
	echo risal_displayonly('File name already exist.');
	}
	} elseif ( $_POST['submit'] == "Update" ) {
	$wpdb->update( 
		$rissettings, 
		array(
		'file' => basename($_POST['myfile']),
		'method' => $_POST['mymeth'], 
		'outsidepath' => $_POST['mypath'],
		'timing' => $_POST['mytime']
		),
		array( 'id' => $_POST['myid']
		));
	echo risal_displayonly('Updated record.');
	} elseif ( $_POST['submit'] == "edit" ) {
	echo risal_displayonly('Editing record.');
	} elseif ( $_POST['submit'] == "remove" ) {
	$myid = $_POST['myid'];
	$wpdb->query("DELETE FROM $rissettings WHERE id = $myid");
	echo risal_displayonly('Record deleted.');
	} elseif ( $_POST['submit'] == "Checking" ) {
	
	echo risal_displayonly('Check updated records.');
	} elseif ( $_POST['submit'] == "delete" ) {
	$dename = $_POST['myfile'];
	$depath = $_POST['mypath'];
	$wpdb->query("DELETE FROM $risfiles WHERE file = '$dename' AND path = '$depath'");
	echo risal_displayonly('Record deleted: '.$depath.' = '.$dename);
	}
///step 2: Create first paragraph and table 1. 
// Button (remove/prepare for edit) will be here.
	echo risal_displayonly('first');
	$queryRisal = $wpdb->get_results( "SELECT * FROM $rissettings" );
	foreach ( $queryRisal as $myrow )
	{
		//if ( $myrow->id % 2 == 0 )	
	
		echo '<tr><th scope="row" class="spec">';
		echo $myrow->id;
		echo '</th><td> ';
		echo $myrow->file;
		echo '</td><td align=center>';
		echo $myrow->method;
		echo '</td><td align=center>';
		echo $myrow->timing;
		echo '</td><td> ';
		echo $myrow->outsidepath;
		echo '</td><td>
	<form action="" method="post"><input type=hidden name="myid" value='.$myrow->id.'>
	<input type="submit" name="submit" value="remove" /></form></td><td>
	<form action="" method="post"><input type=hidden name="myid" value='.$myrow->id.'>
	<input type="submit" name="submit" value="edit" /></form>
	</td></tr>';
	}
///step 3: Create Editor //form to POST (insert/edit) will be here.
	echo '</tbody></table><hr>
		<form id="myform" name=rform class="cssform" method="post" action="">';
	if ( $_POST['submit'] == "edit" && $_POST['myid'] !== "" ) {
		$myid = $_POST['myid'];
		$queryRisal = $wpdb->get_results( "SELECT * FROM $rissettings WHERE id = $myid" );
		foreach ( $queryRisal as $myrow )
		{
		$tris = $myrow->id;
		}
		$vris = "Update";
		$xfile = $myrow->file;
		$xpath = $myrow->outsidepath;
		echo '<h2>Modify Record:</h2>';

		if ( $myrow->method == "md5" ) { $fmd5 = "checked"; $fsha1 = "";}
		if ( $myrow->method == "sha1" ) { $fsha1 = "checked"; $fmd5 = ""; }
	} else {
		$queryRisal = $wpdb->get_var( $wpdb->prepare( "SELECT MAX(id) FROM $rissettings;" ) );
		$tris = $queryRisal + 1;
		$vris = "Insert";
		echo '<h2>Insert New Record:</h2>';
	}
	echo '<p><label for="ID">ID</label><input type=text name="myid" value="'.$tris.'"></p>
		<p><label for="File">Server\'s File Name</label><input type=text name="myfile" value="'.$xfile.'"></p>
		<p><label for="File Path">Server\'s File Path</label><input type=text name="mypath" value="'.$xpath.'"></p>
		<p><input type="button" value="BROWSE FILE" onclick="window.open(\'plugins.php?page=risal&browse=true\')" /></p>
		<p><label for="Method">Method</label><input type="radio" name="mymeth" value="md5" '.$fmd5.'> MD5
		<input type="radio" name="mymeth" value="sha1" '.$fsha1.'> SHA1</p>
		<p><label for="Livetime">Livetime</label><input type=text name="mytime" value="'.$myrow->timing.'"><br>
		(<i> in seconds</i> )</p>
		<p class="submit"><input type="submit" name=submit value="'.$vris.'"></p></form><hr>';
///step 4: Create table 2 and table 3. Remove button will be here.
	echo risal_displayonly('second');
	
	$queryRisal = $wpdb->get_results( "SELECT * FROM $risfiles WHERE valid = 'A'" );
	foreach ( $queryRisal as $myrow )
	{
		$dename = $myrow->file;
		$depath = $myrow->path;
		$queryRiz = $wpdb->get_results( "SELECT timing FROM $rissettings WHERE file = '$dename'" );
		foreach ( $queryRiz as $myrox )
		{
		$timeNow = time();
		$timeStart = strtotime($myrow->timestamp);
		$timeGiven = $myrox->timing;
		$timeLeft = $timeGiven - ($timeNow - $timeStart);
		}
		
		if ( $timeLeft >= 0 )
		{
		/// If time still left display the row, otherwise update flag only
		echo '<tr><th scope="row" class="spec">';
		echo $myrow->file;
		echo '</th><td>';
		$mypath = substr($depath,0,28);
		if ( strlen($depath) <= 28 ) 
		{ echo $myrow->path; } else { echo $mypath.'..'; }
		echo '</td><td>';
		echo $myrow->ip;
		echo '</td><td>';
		echo $timeLeft;
		echo '</td><td>
		<form action="" method="post">
		<input type=hidden name="myfile" value="'.$myrow->file.'">
		<input type=hidden name="mypath" value="'.$myrow->path.'">
		<input type="submit" name="submit" value="delete" />
		</form>
		</td></tr>';	

		} else {
			$wpdb->update( 
			$risfiles, 
			array(
				'valid' => 'E'
			),
			array( 'file' => $dename,	
				'path' => $depath
			));
		}
	}
		
	echo risal_displayonly('third');
	
	$queryRisal = $wpdb->get_results( "SELECT * FROM $risfiles WHERE valid IN ('E','F')" );
	foreach ( $queryRisal as $myrow )
	{
		echo '<tr><th scope="row" class="spec">';
		echo $myrow->file;
		echo '</th><td>';
		$mypax = substr($myrow->path,0,28);
		if ( strlen($myrow->path) <= 28 ) 
		{ echo $myrow->path; } else { echo $mypax.'..'; }
		echo '</td><td>';
		echo $myrow->ip;
		echo '</td><td>';
		if ( $myrow->valid == "E" )
		{
		echo "Expired";
		} else {
		echo "Finished";
		}
		echo '</td><td>
	<form action="" method="post">
	<input type=hidden name="myfile" value="'.$myrow->file.'">
	<input type=hidden name="mypath" value="'.$myrow->path.'">
	<input type="submit" name="submit" value="delete" />
		</form>
		</td></tr>';
	}
	echo '</tbody></table><form action="" method="post">
	<p class="submit"><input type="submit" name="submit" value="Checking" /></p>
	</form></div>';

}

/// admin page separate messy html
function risal_displayonly($tbl_no) {
	if ( $tbl_no == 'first' ) {
	//this is first table
	return '<p>This plugin created to avoid unethical download activity by user. It prohibit user to use download manager, changing between browsers or sessions and such act consider as abuse. Use this plugin by typing below\'s shortcode into html/visual editor:</p><font color=#4f6b72><strong>[risal id=1 file="Hisnul Muslim"]</strong></font><p>Where <i>id</i> refers id\'s number in table 1 and <i>file</i> is whatever name you decide to use. It\'s not depend on filename in database\'s record. Better to use file locate at outside Apache\'s root directory as records but accessible/readable by apache\'s user. It is a bad idea to locate any download-able files inside Apache\'s root directory where it is directly and <i>freely</i> accessible by Internet users. By the way don\'t forget to notice visitors to disable pop-up blocker for your site.</p>
	<h3>List of available files for download:</h3>
	<table id="ristable" cellspacing="0" summary="The record available">
	<caption>Table 1: List of records, available for download</caption>
	<thead>	
	<tr>
	<th scope="col" abbr="ID" class="specalt">ID</th>
	<th scope="col" abbr="File">File</th>
	<th scope="col" abbr="Method">Method</th>
	<th scope="col" abbr="Livetime">Livetime</th>
	<th scope="col" abbr="Path">Outside Path</th>
	<th scope="col" abbr="Remove">Remove</th>
	<th scope="col" abbr="Edit">Edit</th>
	</tr>
	</thead><tbody>';
	
	} elseif ( $tbl_no == 'second' ) {
	//these are 2nd table
	return '
	<h3>User Activities:</h3>
	<table id="ristable" cellspacing="0" summary="The record for download">
	<caption>Table 2: Registered by user\'s activity (by clicked links)</caption>
	<thead>	
	<tr>
	<th scope="col" abbr="File">File</th>
	<th scope="col" abbr="Encrypt">Encrypt</th>
	<th scope="col" abbr="IP">Access IP</th>
	<th scope="col" abbr="Time">Time Left</th>
	<th scope="col" abbr="Remove">Remove</th>
	</thead><tbody>';
	} elseif ( $tbl_no == 'third' ) {
	//these are 3rd table
	return '</tbody>
	</table>
	<h3>History Files (Expired or Finish):</h3>
	<table id="ristable" cellspacing="0" summary="The history records">
	<caption>Table 3: List of activity in history</caption>
	<thead>	
	<tr>
	<th scope="col" abbr="File">File</th>
	<th scope="col" abbr="Encrypt">Encrypt</th>
	<th scope="col" abbr="IP">Access IP</th>
	<th scope="col" abbr="Flag">Flag</th>
	<th scope="col" abbr="Remove">Remove</th>
	</thead><tbody>';
	} else {
	// alert here..
	return '<p style="padding: .5em; background-color: #C0C0C0; font-weight: bold;">'.$tbl_no.'</p>';	
	}
}


//[risal id=3 file="Madarijus Salikin"] "id" refer to mysql db => wpdb.wp_rissettings.id

function risal_func($atts) {
global $wpdb,$ristokens, $toke, $table_prefix;
$ristokens = $table_prefix . 'ristokens';
     extract(shortcode_atts(array(
	      'id' => NULL,
	      'file' => NULL,
     ), $atts));

	/// insert token into table
	$toke = md5(time().$file.$id.rand());
	$wpdb->insert( 
	$ristokens, 
	array( 
		'id' => $id, 
		'token' => $toke,
		'point' => date('Y-m-d H:i:s')
	));
	return "<a href=\"javascript:popUp('".plugin_dir_url( __FILE__ )."downfile.php?filename={$id}&token={$toke}')\">{$file}</a>";
}

//inserts shortcode [risal id=x file=xxxx]
add_shortcode('risal', 'risal_func');

function risal_popup(){
    echo "
<SCRIPT LANGUAGE=\"JavaScript\">
function popUp(URL) {
day = new Date();
id = day.getTime();
eval(\"page\" + id + \" = window.open(URL, '\" + id + \"', 'toolbar=0,scrollbars=0,location=0,statusbar=0,menubar=0,resizable=0,width=150,height=50,left = 540,top = 412');\");
}
</script>
";
}

function risal_browse() {
echo "<script language=\"JavaScript\">
function refreshParent(i,j) {
window.opener.document.rform.myfile.value = i;
window.opener.document.rform.mypath.value = j;
window.close();
}
</script>";
}

//inserts java script into head of document
add_action ( 'wp_head', 'risal_popup' );

function css_admin_head() {
        echo '<link rel="stylesheet" type="text/css" href="' .plugins_url('risal.css', __FILE__). '">';
}

//attache css into admin using ?page=risal argument
if ( $_GET['page'] == 'risal' ) {
add_action('admin_head', 'css_admin_head');
add_action('admin_head', 'risal_browse');
}
?>
